commit 5103de3423da39e0edcbd556ab2633c8d5c09c5f
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Dec 17 15:56:32 2025 +0000

    dscp module

diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index b38fcd360..9b766d6ee 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -332,7 +332,7 @@ done <<-END
  routers    ROUTER	ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
  transports TRANSPORT	APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
  auths	    AUTH	CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
- miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SPF SPF_PERL
+ miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SPF SPF_PERL
 END
 
 # See if there is a definition of EXIM_PERL in what we have built so far.
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 517310c8a..35b58ec04 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -90,7 +90,7 @@ done
 cd ..
 
 # miscellaneous modules
-# Note that the file in the miscmods/pdkim/ source subdir get linked to the 
+# Note that the files in the miscmods/pdkim/ source subdir get linked to the 
 # destination miscmods/ dir
 d="miscmods"
 mkdir $d
@@ -102,6 +102,7 @@ for f in dummy.c \
 	pdkim/crypt_ver.h pdkim/pdkim.c pdkim/pdkim.h \
 	pdkim/pdkim_hash.h pdkim/signing.c pdkim/signing.h \
 	dmarc.c dmarc_common.c dmarc.h dmarc_api.h dmarc_native.c \
+	dscp.c dscp_api.h \
 	exim_filter.c exim_filter_api.h \
 	pam.c pam_api.h \
 	perl.c perl_api.h \
diff --git a/src/src/EDITME b/src/src/EDITME
index 1c9d834dd..98baae7d5 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -577,6 +577,9 @@ SUPPORT_DANE=yes
 
 # SUPPORT_SIEVE_FILTER=2
 
+# Uncomment the line to include DSCP support.  Set to 2 for a module build.
+# SUPPORT_DSCP
+
 #------------------------------------------------------------------------------
 # Compiling Exim with content scanning support: If you want to compile Exim
 # with support for message body content scanning, set WITH_CONTENT_SCAN to
diff --git a/src/src/acl.c b/src/src/acl.c
index 63478ca7d..bc4f6af6d 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -3498,44 +3498,18 @@ for (; cb; cb = cb->next)
 	  f.dmarc_enable_forensic = TRUE;
 	  break;
 #endif
-
+#ifdef SUPPORT_DSCP
 	case CONTROL_DSCP:
-	  if (*p == '/')
-	    {
-	    int af, socklevel, optname, value;
-	    /* If we are acting on stdin, the setsockopt may fail if stdin is not
-	    a socket; we can accept that, we'll just debug-log failures anyway. */
-	    if (smtp_in_fd < 0) return ERROR;
-	    if ((af = ip_get_address_family(smtp_in_fd)) < 0)
-	      {
-	      HDEBUG(D_acl)
-		debug_printf_indent("smtp input is probably not a socket [%s], not setting DSCP\n",
-		    strerror(errno));
-	      break;
-	      }
-	    if (dscp_lookup(p+1, af, &socklevel, &optname, &value))
-	      if (setsockopt(smtp_in_fd, socklevel, optname,
-			    &value, sizeof(value)) < 0)
-		{
-		HDEBUG(D_acl) debug_printf_indent("failed to set input DSCP[%s]: %s\n",
-		    p+1, strerror(errno));
-		}
-	      else
-		{
-		HDEBUG(D_acl) debug_printf_indent("set input DSCP to %q\n", p+1);
-		}
-	    else
-	      {
-	      *log_msgptr = string_sprintf("unrecognised DSCP value in \"control=%s\"", arg);
-	      return ERROR;
-	      }
-	    }
-	  else
-	    {
-	    *log_msgptr = string_sprintf("syntax error in \"control=%s\"", arg);
-	    return ERROR;
-	    }
+	  {
+	  misc_module_info * mi = misc_mod_find(US"dscp", &log_message);
+	  typedef uschar * (*fn_t)(const uschar *, const uschar *);
+	  if (!mi)
+	    rc = DEFER;
+	  else if ((*log_msgptr = ((fn_t *) mi->functions)[DSCP_ACL] (arg, p)))
+	    rc = ERROR;
 	  break;
+	  }
+#endif
 
 	case CONTROL_ERROR:
 	  return ERROR;
diff --git a/src/src/config.h.defaults b/src/src/config.h.defaults
index 71146ae3b..ba9f50b01 100644
--- a/src/src/config.h.defaults
+++ b/src/src/config.h.defaults
@@ -155,6 +155,7 @@ Do not put spaces between # and the 'define'.
 #define SUPPORT_DMARC
 #define DMARC_API 100400
 #define DMARC_TLD_FILE "/etc/exim/opendmarc.tlds"
+#define SUPPORT_DSCP
 #define SUPPORT_I18N
 #define SUPPORT_I18N_2008
 #define SUPPORT_MAILDIR
diff --git a/src/src/drtables.c b/src/src/drtables.c
index bf1c3e530..e21d47047 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -356,7 +356,7 @@ return NULL;
 
 int
 misc_mod_conn_init(const uschar * sender_helo_name,
-  const uschar * sender_host_address, const uschar * * errstr)
+  const uschar * sender_host_address, const uschar ** errstr)
 {
 for (const misc_module_info * mi = misc_module_list; mi; mi = mi->next)
   if (mi->conn_init)
@@ -495,6 +495,9 @@ extern misc_module_info spf_module_info;
 #if defined(EXPERIMENTAL_ARC) && (!defined(SUPPORT_ARC) || SUPPORT_ARC!=2)
 extern misc_module_info arc_module_info;
 #endif
+#if defined(SUPPORT_DSCP) && SUPPORT_DSCP!=2
+extern misc_module_info dscp_module_info;
+#endif
 #if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
 extern misc_module_info radius_module_info;
 #endif
@@ -531,6 +534,9 @@ onetime = TRUE;
 /* dmarc depends on spf/dkim/arc so this add must go after, for the both-static case */
   misc_mod_add(&dmarc_module_info);
 #endif
+#if defined(SUPPORT_DSCP) && SUPPORT_DSCP!=2
+  misc_mod_add(&dscp_module_info);
+#endif
 #if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
   misc_mod_add(&radius_module_info);
 #endif
diff --git a/src/src/exim.c b/src/src/exim.c
index 693301899..383fe8247 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -1186,6 +1186,9 @@ g = string_cat(g, US"Support for:");
 #ifndef DISABLE_DNSSEC
   g = string_cat(g, US" DNSSEC");
 #endif
+#ifdef SUPPORT_DSCP
+  g = string_cat(g, US" DSCP");
+#endif
 #ifndef DISABLE_ESMTP_LIMITS
   g = string_cat(g, US" ESMTP_Limits");
 #endif
@@ -1382,7 +1385,9 @@ switch(request)
 "If the string is not recognised, you'll get this help (on stderr).\n"
 "\n"
 "  exim -bI:help    this information\n"
+#ifdef SUPPORT_DSCP
 "  exim -bI:dscp    list of known dscp value keywords\n"
+#endif
 "  exim -bI:sieve   list of supported sieve extensions\n"
 );
     return;
@@ -1396,9 +1401,16 @@ switch(request)
       fprintf(stream, "Sieve filtering not available\n");
     }
     return;
+#ifdef SUPPORT_DSCP
   case CMDINFO_DSCP:
-    dscp_list_to_stream(stream);
+    {
+    uschar * dummy_errstr;
+    misc_module_info * mi = misc_mod_find(US"dscp", &dummy_errstr);
+    typedef void (*fn_t)(FILE *);
+    if (mi) ((fn_t *) mi->functions)[DSCP_KEYWORDS] (stream);
+    }
     return;
+#endif
   }
 }
 
@@ -2419,15 +2431,11 @@ on the second character (the one after '-'), to save some effort. */
 	    info_flag = CMDINFO_HELP;
 	    if (Ustrlen(p))
 	      if (strcmpic(p, CUS"sieve") == 0)
-		{
-		info_flag = CMDINFO_SIEVE;
-		info_stdout = TRUE;
-		}
+		{ info_flag = CMDINFO_SIEVE; info_stdout = TRUE; }
+#ifdef SUPPORT_DSCP
 	      else if (strcmpic(p, CUS"dscp") == 0)
-		{
-		info_flag = CMDINFO_DSCP;
-		info_stdout = TRUE;
-		}
+		{ info_flag = CMDINFO_DSCP; info_stdout = TRUE; }
+#endif
 	      else if (strcmpic(p, CUS"help") == 0)
 		info_stdout = TRUE;
 	    }
diff --git a/src/src/exim.h b/src/src/exim.h
index 538f354e2..07b017a01 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -558,6 +558,9 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #ifdef EXPERIMENTAL_ARC
 # include "miscmods/arc_api.h"
 #endif
+#ifdef SUPPORT_DSCP
+# include "miscmods/dscp_api.h"
+#endif
 #ifdef RADIUS_CONFIG_FILE
 # include "miscmods/radius_api.h"
 #endif
diff --git a/src/src/expand.c b/src/src/expand.c
index e222e8e75..b0500037d 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -8753,8 +8753,7 @@ uschar *
 expand_string_copy(const uschar * string)
 {
 const uschar * yield = expand_string(string);
-if (yield == string) yield = string_copy(string);
-return US yield;
+return yield == string ? string_copy(string) : US yield;
 }
 
 
diff --git a/src/src/functions.h b/src/src/functions.h
index ec13c544e..4e56c14a4 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -216,8 +216,6 @@ extern void    dns_pattern_init(void);
 extern int     dns_special_lookup(dns_answer *, const uschar *, int, const uschar **);
 extern dns_record *dns_next_rr(const dns_answer *, dns_scan *, int);
 extern uschar *dns_text_type(int);
-extern void    dscp_list_to_stream(FILE *);
-extern BOOL    dscp_lookup(const uschar *, int, int *, int *, int *);
 
 extern void    enq_end(uschar *);
 extern unsigned enq_start(uschar *, unsigned);
@@ -290,7 +288,6 @@ extern int     ip_bind(int, int, const uschar *, int);
 extern int     ip_connect(int, int, const uschar *, int, int, const blob *);
 extern int     ip_connectedsocket(int, const uschar *, int, int,
                  int, host_item *, uschar **, const blob *);
-extern int     ip_get_address_family(int);
 extern void    ip_keepalive(int, const uschar *, BOOL);
 extern int     ip_recv(client_conn_ctx *, uschar *, int, time_t);
 extern int     ip_socket(int, int);
diff --git a/src/src/ip.c b/src/src/ip.c
index f48fa82a9..80038e3ec 100644
--- a/src/src/ip.c
+++ b/src/src/ip.c
@@ -681,179 +681,6 @@ return -1;
 
 
 
-
-/*************************************************
-*    Lookup address family of potential socket   *
-*************************************************/
-
-/* Given a file-descriptor, check to see if it's a socket and, if so,
-return the address family; detects IPv4 vs IPv6.  If not a socket then
-return -1.
-
-The value 0 is typically AF_UNSPEC, which should not be seen on a connected
-fd.  If the return is -1, the errno will be from getsockname(); probably
-ENOTSOCK or ECONNRESET.
-
-Arguments:     socket-or-not fd
-Returns:       address family or -1
-*/
-
-int
-ip_get_address_family(int fd)
-{
-struct sockaddr_storage ss;
-socklen_t sslen = sizeof(ss);
-
-if (getsockname(fd, (struct sockaddr *) &ss, &sslen) < 0)
-  return -1;
-
-return (int) ss.ss_family;
-}
-
-
-
-
-/*************************************************
-*       Lookup DSCP settings for a socket        *
-*************************************************/
-
-struct dscp_name_tableentry {
-  const uschar *name;
-  int value;
-};
-/* Keep both of these tables sorted! */
-static struct dscp_name_tableentry dscp_table[] = {
-#ifdef IPTOS_DSCP_AF11
-    { CUS"af11", IPTOS_DSCP_AF11 },
-    { CUS"af12", IPTOS_DSCP_AF12 },
-    { CUS"af13", IPTOS_DSCP_AF13 },
-    { CUS"af21", IPTOS_DSCP_AF21 },
-    { CUS"af22", IPTOS_DSCP_AF22 },
-    { CUS"af23", IPTOS_DSCP_AF23 },
-    { CUS"af31", IPTOS_DSCP_AF31 },
-    { CUS"af32", IPTOS_DSCP_AF32 },
-    { CUS"af33", IPTOS_DSCP_AF33 },
-    { CUS"af41", IPTOS_DSCP_AF41 },
-    { CUS"af42", IPTOS_DSCP_AF42 },
-    { CUS"af43", IPTOS_DSCP_AF43 },
-    { CUS"ef", IPTOS_DSCP_EF },
-#endif
-#ifdef IPTOS_LOWCOST
-    { CUS"lowcost", IPTOS_LOWCOST },
-#endif
-    { CUS"lowdelay", IPTOS_LOWDELAY },
-#ifdef IPTOS_MINCOST
-    { CUS"mincost", IPTOS_MINCOST },
-#endif
-    { CUS"reliability", IPTOS_RELIABILITY },
-    { CUS"throughput", IPTOS_THROUGHPUT }
-};
-static int dscp_table_size =
-  sizeof(dscp_table) / sizeof(struct dscp_name_tableentry);
-
-/* DSCP values change by protocol family, and so do the options used for
-setsockopt(); this utility does all the lookups.  It takes an unexpanded
-option string, expands it, strips off affix whitespace, then checks if it's
-a number.  If all of what's left is a number, then that's how the option will
-be parsed and success/failure is a range check.  If it's not all a number,
-then it must be a supported keyword.
-
-Arguments:
-  dscp_name   a string, so far unvalidated
-  af          address_family in use
-  level       setsockopt level to use
-  optname     setsockopt name to use
-  dscp_value  value for dscp_name
-
-Returns: TRUE if okay to setsockopt(), else FALSE
-
-*level and *optname may be set even if FALSE is returned
-*/
-
-BOOL
-dscp_lookup(const uschar *dscp_name, int af,
-    int *level, int *optname, int *dscp_value)
-{
-uschar *dscp_lookup, *p;
-int first, last;
-long rawlong;
-
-if (af == AF_INET)
-  {
-  *level = IPPROTO_IP;
-  *optname = IP_TOS;
-  }
-#if HAVE_IPV6 && defined(IPV6_TCLASS)
-else if (af == AF_INET6)
-  {
-  *level = IPPROTO_IPV6;
-  *optname = IPV6_TCLASS;
-  }
-#endif
-else
-  {
-  DEBUG(D_transport)
-    debug_printf("Unhandled address family %d in dscp_lookup()\n", af);
-  return FALSE;
-  }
-if (!dscp_name)
-  {
-  DEBUG(D_transport)
-    debug_printf("[empty DSCP]\n");
-  return FALSE;
-  }
-dscp_lookup = expand_string(US dscp_name);
-if (dscp_lookup == NULL || *dscp_lookup == '\0')
-  return FALSE;
-
-p = dscp_lookup + Ustrlen(dscp_lookup) - 1;
-while (isspace(*p)) *p-- = '\0';
-while (isspace(*dscp_lookup) && dscp_lookup < p) dscp_lookup++;
-if (*dscp_lookup == '\0')
-  return FALSE;
-
-rawlong = Ustrtol(dscp_lookup, &p, 0);
-if (p != dscp_lookup && *p == '\0')
-  {
-  /* We have six bits available, which will end up shifted to fit in 0xFC mask.
-  RFC 2597 defines the values unshifted. */
-  if (rawlong < 0 || rawlong > 0x3F)
-    {
-    DEBUG(D_transport)
-      debug_printf("DSCP value %ld out of range, ignored.\n", rawlong);
-    return FALSE;
-    }
-  *dscp_value = rawlong << 2;
-  return TRUE;
-  }
-
-first = 0;
-last = dscp_table_size;
-while (last > first)
-  {
-  int middle = (first + last)/2;
-  int c = Ustrcmp(dscp_lookup, dscp_table[middle].name);
-  if (c == 0)
-    {
-    *dscp_value = dscp_table[middle].value;
-    return TRUE;
-    }
-  else if (c > 0)
-    first = middle + 1;
-  else
-    last = middle;
-  }
-return FALSE;
-}
-
-void
-dscp_list_to_stream(FILE *stream)
-{
-for (int i = 0; i < dscp_table_size; ++i)
-  fprintf(stream, "%s\n", dscp_table[i].name);
-}
-
-
 /* End of ip.c */
 /* vi: aw ai sw=2
 */
diff --git a/src/src/macro_predef.c b/src/src/macro_predef.c
index a8ebc40d4..4778ace64 100644
--- a/src/src/macro_predef.c
+++ b/src/src/macro_predef.c
@@ -212,6 +212,9 @@ due to conflicts with other common macros. */
 #ifdef EXPERIMENTAL_DCC
   builtin_macro_create(US"_HAVE_DCC");
 #endif
+#ifdef SUPPORT_DSCP
+  builtin_macro_create(US"_HAVE_DSCP");
+#endif
 #ifdef EXPERIMENTAL_DSN_INFO
   builtin_macro_create(US"_HAVE_DSN_INFO");
 #endif
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index 2d44059ba..e129fe8bc 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -41,6 +41,7 @@ dmarc.o dmarc.so:		$(HDRS) spf.h pdkim.h dmarc.h \
 				dmarc.c dmarc_common.c
 dmarc_native.o dmarc_native.so:	$(HDRS) spf.h pdkim.h dmarc.h \
 				dmarc_native.c dmarc_common.c
+dscp.o  dscp.so:		$(HDRS) dscp.c
 dummy.o:			dummy.c
 exim_filter.o exim_filter.so:	$(HDRS) exim_filter.c
 pam.o   pam.so:			$(HDRS) pam.c
diff --git a/src/src/miscmods/dscp.c b/src/src/miscmods/dscp.c
new file mode 100644
index 000000000..8c25833d9
--- /dev/null
+++ b/src/src/miscmods/dscp.c
@@ -0,0 +1,278 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* DSCP support for Exim
+   Copyright (c) The Exim Maintainers - 2025
+   License: GPL
+   SPDX-License-Identifier: GPL-2.0-or-later
+*/
+
+#include "../exim.h"
+#if defined SUPPORT_DSCP
+
+# include "../functions.h"
+
+/******************************************************************************/
+/* Utility functions */
+
+/*************************************************
+*    Lookup address family of potential socket   *
+*************************************************/
+
+/* Given a file-descriptor, check to see if it's a socket and, if so,
+return the address family; detects IPv4 vs IPv6.  If not a socket then
+return -1.
+
+The value 0 is typically AF_UNSPEC, which should not be seen on a connected
+fd.  If the return is -1, the errno will be from getsockname(); probably
+ENOTSOCK or ECONNRESET.
+
+Arguments:     socket-or-not fd
+Returns:       address family or -1
+*/
+
+static int
+ip_get_address_family(int fd)
+{
+struct sockaddr_storage ss;
+socklen_t sslen = sizeof(ss);
+
+if (getsockname(fd, (struct sockaddr *) &ss, &sslen) < 0)
+  return -1;
+
+return (int) ss.ss_family;
+}
+
+
+
+/*************************************************
+*       Lookup DSCP settings for a socket        *
+*************************************************/
+
+struct dscp_name_tableentry {
+  const uschar *name;
+  int value;
+};
+/* Keep both of these tables sorted! */
+static struct dscp_name_tableentry dscp_table[] = {
+#ifdef IPTOS_DSCP_AF11
+    { CUS"af11", IPTOS_DSCP_AF11 },
+    { CUS"af12", IPTOS_DSCP_AF12 },
+    { CUS"af13", IPTOS_DSCP_AF13 },
+    { CUS"af21", IPTOS_DSCP_AF21 },
+    { CUS"af22", IPTOS_DSCP_AF22 },
+    { CUS"af23", IPTOS_DSCP_AF23 },
+    { CUS"af31", IPTOS_DSCP_AF31 },
+    { CUS"af32", IPTOS_DSCP_AF32 },
+    { CUS"af33", IPTOS_DSCP_AF33 },
+    { CUS"af41", IPTOS_DSCP_AF41 },
+    { CUS"af42", IPTOS_DSCP_AF42 },
+    { CUS"af43", IPTOS_DSCP_AF43 },
+    { CUS"ef", IPTOS_DSCP_EF },
+#endif
+#ifdef IPTOS_LOWCOST
+    { CUS"lowcost", IPTOS_LOWCOST },
+#endif
+    { CUS"lowdelay", IPTOS_LOWDELAY },
+#ifdef IPTOS_MINCOST
+    { CUS"mincost", IPTOS_MINCOST },
+#endif
+    { CUS"reliability", IPTOS_RELIABILITY },
+    { CUS"throughput", IPTOS_THROUGHPUT }
+};
+static int dscp_table_size =
+  sizeof(dscp_table) / sizeof(struct dscp_name_tableentry);
+
+/* DSCP values change by protocol family, and so do the options used for
+setsockopt(); this utility does all the lookups.  It takes an unexpanded
+option string, expands it, strips off affix whitespace, then checks if it's
+a number.  If all of what's left is a number, then that's how the option will
+be parsed and success/failure is a range check.  If it's not all a number,
+then it must be a supported keyword.
+
+Arguments:
+  dscp_name   a string, so far unvalidated
+  af          address_family in use
+  level       setsockopt level to use
+  optname     setsockopt name to use
+  dscp_value  value for dscp_name
+
+Returns: TRUE if okay to setsockopt(), else FALSE
+
+*level and *optname may be set even if FALSE is returned
+*/
+
+static BOOL
+dscp_lookup(const uschar * dscp_name, int af,
+    int * level, int * optname, int * dscp_value)
+{
+uschar * dscp_lookup, * p;
+int first, last;
+long rawlong;
+
+if (af == AF_INET)
+  { *level = IPPROTO_IP; *optname = IP_TOS; }
+#if HAVE_IPV6 && defined(IPV6_TCLASS)
+else if (af == AF_INET6)
+  { *level = IPPROTO_IPV6; *optname = IPV6_TCLASS; }
+#endif
+else
+  {
+  DEBUG(D_transport)
+    debug_printf("Unhandled address family %d in dscp_lookup()\n", af);
+  return FALSE;
+  }
+if (!dscp_name)
+  {
+  DEBUG(D_transport)
+    debug_printf("[empty DSCP]\n");
+  return FALSE;
+  }
+dscp_lookup = expand_string_copy(dscp_name);
+if (!dscp_lookup || !*dscp_lookup)
+  return FALSE;
+
+p = dscp_lookup + Ustrlen(dscp_lookup) - 1;
+while (isspace(*p)) *p-- = '\0';
+while (isspace(*dscp_lookup) && dscp_lookup < p) dscp_lookup++;
+if (*dscp_lookup == '\0')
+  return FALSE;
+
+rawlong = Ustrtol(dscp_lookup, &p, 0);
+if (p != dscp_lookup && *p == '\0')
+  {
+  /* We have six bits available, which will end up shifted to fit in 0xFC mask.
+  RFC 2597 defines the values unshifted. */
+  if (rawlong < 0 || rawlong > 0x3F)
+    {
+    DEBUG(D_transport)
+      debug_printf("DSCP value %ld out of range, ignored.\n", rawlong);
+    return FALSE;
+    }
+  *dscp_value = rawlong << 2;
+  return TRUE;
+  }
+
+first = 0;
+last = dscp_table_size;
+while (last > first)
+  {
+  int middle = (first + last)/2;
+  int c = Ustrcmp(dscp_lookup, dscp_table[middle].name);
+  if (c == 0)
+    {
+    *dscp_value = dscp_table[middle].value;
+    return TRUE;
+    }
+  else if (c > 0)
+    first = middle + 1;
+  else
+    last = middle;
+  }
+return FALSE;
+}
+
+/******************************************************************************/
+
+/*API
+Set DSCP on stdin.  Called from ACL control.
+Return error message on fail, NULL on ok.
+*/
+
+static uschar *
+dscp_acl(const uschar * control, const uschar * opt)
+{
+int af, socklevel, optname, value;
+
+if (*opt != '/')
+  return string_sprintf("syntax error in \"control=%s\"", control);
+
+/* If we are acting on stdin, the setsockopt may fail if stdin is
+not a socket; we can accept that, we'll just debug-log failures
+anyway. */
+if (smtp_in_fd < 0) return US"no stdin";
+if ((af = ip_get_address_family(smtp_in_fd)) < 0)
+  {
+  HDEBUG(D_acl) debug_printf_indent(
+    "smtp input is probably not a socket [%s], not setting DSCP\n",
+    strerror(errno));
+  return NULL;
+  }
+if (!dscp_lookup(++opt, af, &socklevel, &optname, &value))
+  return string_sprintf("unrecognised DSCP value in \"control=%s\"", control);
+
+value = setsockopt(smtp_in_fd, socklevel, optname,
+		    &value, sizeof(value));
+HDEBUG(D_acl)
+  if (value < 0)
+    debug_printf_indent("failed to set input DSCP[%s]: %s\n",
+      opt, strerror(errno));
+  else
+    debug_printf_indent("set input DSCP to %q\n", opt);
+return NULL;
+}
+
+
+/*API
+Set DSCP on given socket; called from smtp transport.
+Can silently fail.
+*/
+
+static void
+dscp_transport(int sock, const uschar * dscp_str, int host_af)
+{
+int dscp_value, dscp_level, dscp_option;
+
+if (  dscp_str
+   && dscp_lookup(dscp_str, host_af, &dscp_level, &dscp_option, &dscp_value)
+   )
+  {
+  HDEBUG(D_transport|D_acl|D_v)
+    debug_printf_indent("DSCP %q=%x ", dscp_str, dscp_value);
+
+  if (setsockopt(sock, dscp_level, dscp_option, &dscp_value, sizeof(dscp_value)) < 0)
+    HDEBUG(D_transport|D_acl|D_v)
+      debug_printf_indent("failed to set DSCP: %s ", strerror(errno));
+
+  /* If the kernel supports IPv4 and IPv6 on an IPv6 socket, we need to set the
+  option for both; ignore failures here */
+
+  if (  host_af == AF_INET6
+     && dscp_lookup(dscp_str, AF_INET, &dscp_level, &dscp_option, &dscp_value)
+     )
+    (void) setsockopt(sock, dscp_level, dscp_option, &dscp_value, sizeof(dscp_value));
+  }
+}
+
+
+/*API: output known DSCP names */
+static void
+dscp_keywords(FILE * stream)
+{
+for (int i = 0; i < dscp_table_size; ++i)
+  fprintf(stream, "%s\n", dscp_table[i].name);
+}
+
+/******************************************************************************/
+/* Module API */
+
+static void * dscp_functions[] = {
+  [DSCP_ACL] =		(void *) dscp_acl,
+  [DSCP_TRANSPORT] =	(void *) dscp_transport,
+  [DSCP_KEYWORDS] =	(void *) dscp_keywords,
+};
+
+misc_module_info dscp_module_info =
+{
+  .name =		US"dscp",
+# ifdef DYNLOOKUP
+  .dyn_magic =		MISC_MODULE_MAGIC,
+# endif
+  .functions =		dscp_functions,
+  .functions_count =	nelem(dscp_functions),
+};
+
+#endif /* SUPPORT_DSCP */
+/* vi: aw ai sw=2
+ */
diff --git a/src/src/miscmods/dscp_api.h b/src/src/miscmods/dscp_api.h
new file mode 100644
index 000000000..ce355319d
--- /dev/null
+++ b/src/src/miscmods/dscp_api.h
@@ -0,0 +1,16 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+/* API definitions for the arcmodule */
+
+
+/* Function table entry numbers */
+
+#define	DSCP_ACL		0
+#define	DSCP_TRANSPORT		1
+#define	DSCP_KEYWORDS		2
diff --git a/src/src/smtp_out.c b/src/src/smtp_out.c
index 465acb5ed..790a0c005 100644
--- a/src/src/smtp_out.c
+++ b/src/src/smtp_out.c
@@ -276,10 +276,7 @@ Update those with the state.  Return the fd, or -1 with errno set.
 int
 smtp_boundsock(smtp_connect_args * sc)
 {
-transport_instance * tb = sc->tblock;
-smtp_transport_options_block * ob = tb->drinst.options_block;
-const uschar * dscp = ob->dscp;
-int sock, dscp_value, dscp_level, dscp_option;
+int sock;
 
 if ((sock = ip_socket(SOCK_STREAM, sc->host_af)) < 0)
   return -1;
@@ -290,23 +287,23 @@ if (setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, US &on, sizeof(on)))
   HDEBUG(D_transport|D_acl|D_v)
     debug_printf_indent("failed to set NODELAY: %s ", strerror(errno));
 
+#ifdef SUPPORT_DSCP
 /* Set DSCP value, if we can. For now, if we fail to set the value, we don't
 bomb out, just log it and continue in default traffic class. */
-
-GET_OPTION("dscp");
-if (dscp && dscp_lookup(dscp, sc->host_af, &dscp_level, &dscp_option, &dscp_value))
   {
-  HDEBUG(D_transport|D_acl|D_v)
-    debug_printf_indent("DSCP %q=%x ", dscp, dscp_value);
-  if (setsockopt(sock, dscp_level, dscp_option, &dscp_value, sizeof(dscp_value)) < 0)
-    HDEBUG(D_transport|D_acl|D_v)
-      debug_printf_indent("failed to set DSCP: %s ", strerror(errno));
-  /* If the kernel supports IPv4 and IPv6 on an IPv6 socket, we need to set the
-  option for both; ignore failures here */
-  if (sc->host_af == AF_INET6 &&
-      dscp_lookup(dscp, AF_INET, &dscp_level, &dscp_option, &dscp_value))
-    (void) setsockopt(sock, dscp_level, dscp_option, &dscp_value, sizeof(dscp_value));
+  transport_instance * tb = sc->tblock;
+  smtp_transport_options_block * ob = tb->drinst.options_block;
+  GET_OPTION("dscp");
+  if (ob->dscp)
+    {
+    uschar * dummy_errstr;
+    misc_module_info * mi = misc_mod_find(US"dscp", &dummy_errstr);
+    typedef void (*fn_t)(int, const uschar *, int);
+    if (mi)
+      ((fn_t *) mi->functions)[DSCP_TRANSPORT] (sock, ob->dscp, sc->host_af);
+    }
   }
+#endif
 
 /* Bind to a specific interface if requested. Caller must ensure the interface
 is the same type (IPv4 or IPv6) as the outgoing address. */

